<?php

namespace SenSai;

use ManiaControl\ManiaControl;
use ManiaControl\Plugins\Plugin;
use ManiaControl\Players\Player;
use ManiaControl\Players\PlayerManager;
use ManiaControl\Callbacks\Callbacks;
use ManiaControl\Callbacks\CallbackListener;
use ManiaControl\Callbacks\CallbackManager;
use ManiaControl\Callbacks\TimerListener;
use ManiaControl\Callbacks\TimerManager;
use ManiaControl\Settings\SettingManager;


/**
 * ManiaControl Promote Plugin
 *
 * @author G]R [SG-1] Sen-Sai
 */
class PromotePlugin implements CallbackListener, Plugin, TimerListener {
	/**
	 * Constants
	 */
	const PLUGIN_ID				= 55;
	const PLUGIN_VERSION		= 1;
	const PLUGIN_NAME			= 'PromotePlugin';
	const PLUGIN_AUTHOR			= 'G]R [SG-1]Sen-sai';
	const DATE					= 'd-m-y h:i:sa T';

	const SETTING_PROMOTE_INTERVAL 		= 'Promote Interval';
	const SETTING_PROMOTE_MODE 			= 'Promote Mode'; // random or linear
	const SETTING_PROMOTE_TXT_0 		= 'Promote text A';
	const SETTING_PROMOTE_TXT_1 		= 'Promote text B';
	const SETTING_PROMOTE_TXT_2 		= 'Promote text C';
	const SETTING_PROMOTE_TXT_3 		= 'Promote text D';
	const SETTING_PROMOTE_TXT_4 		= 'Promote text E';
	const SETTING_PROMOTE_TXT_5 		= 'Promote text F';
	const SETTING_PROMOTE_TXT_6 		= 'Promote text G';
	const SETTING_PROMOTE_TXT_7 		= 'Promote text H';
	const SETTING_PROMOTE_TXT_8 		= 'Promote text I';
	const SETTING_PROMOTE_TXT_9 		= 'Promote text J';



	/**
	 * Private properties
	 */
	/** @var maniaControl $maniaControl */
	private $maniaControl = null;
	private $message = array();
	private $nextMsg = 0;
	private $msgIndex = 0;

	/**
	 * Prepares the Plugin
	 *
	 * @param ManiaControl $maniaControl
	 * @return mixed
	 */
	public static function prepare(ManiaControl $maniaControl) {
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_INTERVAL, 120);
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_MODE, 'random'); //random or linear
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_0, 'Type /list to add a map to the Jukebox.');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_1, 'Type /donate [planets] to donate to this server.');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_2, 'Rate this map by writing ++, or -- in the chat!');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_3, 'Like us on $l[https://www.facebook.com/glimratten]Facebook$l.');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_4, '');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_5, '');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_6, '');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_7, '');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_8, '');
		$maniaControl->settingManager->initSetting(get_class(), self::SETTING_PROMOTE_TXT_9, '');		
		
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::load()
	 */
	public function load(ManiaControl $maniaControl) {
		$this->maniaControl = $maniaControl;
		
		$this->loadIntoArray();
		
		$this->nextMsg = time() + (int)$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_INTERVAL);
		
		$this->maniaControl->callbackManager->registerCallbackListener(SettingManager::CB_SETTING_CHANGED, $this, 'handleSettingChangedCallback');
		$this->maniaControl->timerManager->registerTimerListening($this, 'handle1Second', 1000);
		
		return true;
	}
	/**
	 * @see \ManiaControl\Plugins\Plugin::unload()
	 */
	public function unload() {
		
	}
	
	public function loadIntoArray()
	{
		$this->message = array();
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_0) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_0);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_1) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_1);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_2) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_2);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_3) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_3);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_4) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_4);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_5) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_5);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_6) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_6);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_7) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_7);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_8) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_8);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_9) != '')
		{
			$this->message[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_TXT_9);
		}
	}


	public function handleSettingChangedCallback($settingClass) {
		if ($settingClass !== get_class()) {
			return;
		}
		$this->loadIntoArray();
		$this->nextMsg = time() + (int)$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_INTERVAL);
		$this->maniaControl->chat->sendInformation("Promotional settings save. Interval: ".(string)$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_INTERVAL), null, false);
	}
	
	public function handle1Second() {
		if (time() > $this->nextMsg)
		{
			$preTxt = '$0FFServer info: $fff';
			$this->nextMsg = time() + (int)$this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_INTERVAL);
			if (count($this->message) < 2)
			{
				$this->maniaControl->chat->sendInformation($preTxt.(string)$this->message[0], null, false);
			}
			else
			{
				if (strtolower($this->maniaControl->settingManager->getSetting($this, self::SETTING_PROMOTE_MODE)) == 'linear') 
				{
					$this->maniaControl->chat->sendInformation($preTxt.(string)$this->message[$this->msgIndex], null, false);
					$this->msgIndex++;

					if ($this->msgIndex == count($this->message))
					{
						$this->msgIndex = 0;
					}
					
				}
				else
				{
					$index = rand(0,count($this->message)-1);
					$this->maniaControl->chat->sendInformation($preTxt.(string)$this->message[$index], null, false);
				}
				
			}
		}
	}
	
	/**
	 * @see \ManiaControl\Plugins\Plugin::getId()
	 */
	public static function getId() {
		return self::PLUGIN_ID;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getName()
	 */
	public static function getName() {
		return self::PLUGIN_NAME;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getVersion()
	 */
	public static function getVersion() {
		return self::PLUGIN_VERSION;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getAuthor()
	 */
	public static function getAuthor() {
		return self::PLUGIN_AUTHOR;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getDescription()
	 */
	public static function getDescription() {
		return 'Can show up to 10 promotional messages.';
	}


}
